unit hiMainForm;

interface

{$I share.inc}

uses Windows,Kol,Share,Win,Messages{,KOLMHToolTip};

type
 THIPosition = procedure of object;
 THIMainForm = class(THIWin)
   private
     IsMain:boolean;
     First:boolean;
     BitMap: PBitMap;
     isIconSet:boolean; //!!!!!

     procedure SetCaption(const Value:string);
     procedure SetBorderStyle(Value:byte);
     procedure SetWindowsState(Value:byte);
     procedure SetTaskBar(Value:byte);
     procedure SetIcon(value:HICON);
     procedure SetPicture(Value:HBITMAP);
     procedure SetAlphaBlendValue(Value:byte);

     procedure Load;

     procedure _onMouseDown(Sender: PControl; var Mouse: TMouseEventData); override;
     function  _onMessage( var Msg: TMsg; var Rslt: Integer ): Boolean; override;
     procedure _onShow(Obj:PObj);
     procedure _onDestroy(Obj:PObj);
     procedure _OnClose( Sender: PObj; var Accept: Boolean );
     procedure _OnPaint( Sender: PControl; DC: HDC );
   public
     _prop_ShowType:byte;
     _prop_DragForm:boolean;
     _prop_AlphaBlendValue:byte;
     _prop_WindowsState:byte;
     _prop_SavePosition:procedure(State:boolean) of object;
     _prop_SavePosName:string;
     //_prop_BorderStyle:byte;
     _prop_TransparentColor:TColor;
     _prop_ShowIcon:boolean;
     _prop_ClientSize:boolean;
     _prop_Position:THIPosition;

     _data_Close:THI_Event;
     _event_onClick:THI_Event;
     _event_onActivate:THI_Event;
     _event_onDeactivate:THI_Event;
     _event_onShow:THI_Event;
     _event_onCreate:THI_Event;
     _event_onMove:THI_Event;
     _event_onPaint:THI_Event;
     _event_onClose:THI_Event;

     constructor Create(Parent:PControl);
     destructor Destroy; override;
     procedure Init; override;
     procedure Start;

     procedure None(State:boolean);
     procedure Registry(State:boolean);
     procedure IniFile(State:boolean);

     procedure poNone;
     procedure poCenter;

     procedure _work_doCaption(var Data:TData; Index:word);
     procedure _work_doRestore(var Data:TData; Index:word);
     procedure _work_doMinimize(var Data:TData; Index:word);
     procedure _work_doAlphaBlendValue(var Data:TData; Index:word);
     procedure _work_doClose(var Data:TData; Index:word);
     procedure _work_doVisible(var Data:TData; Index:word);
     procedure _work_doPicture(var Data:TData; Index:word);
     procedure _work_doFlashWindow(var _Data:TData; Index:word);
     procedure _work_doIcon(var _Data:TData; Index:word);

     procedure _work_doBorderStyle(var _Data:TData; Index:word);

     property _prop_Caption:string write SetCaption;
     property _prop_Icon:HICON write SetIcon;
     property _prop_TaskBar:byte write SetTaskBar;
     property _prop_Picture:HBITMAP write SetPicture;
     //property _prop_AlphaBlendValue:byte write SetAlphaBlendValue;
     property _prop_BorderStyle:byte write SetBorderStyle;
 end;

 procedure CreateCoolControl(Handle:cardinal; BitMap:PBitMap; tr:TColor = clWhite; _del:boolean = true);

implementation

constructor THIMainForm.Create;
begin
   inherited Create(Parent);

   if not Assigned(Applet) then
     begin
       Applet := NewApplet('');
       //DlgForm.Style := 0;
       IsMain := true;
     end
   else IsMain := false;

   if FParent = nil then Control := NewForm(Applet,'Form')
   else Control := NewForm(FParent,'Form');
   //if ismain then
   //  NewMDIClient(Control,0)
   //else NewMDIChild(Parent,'Form');
   with Control{$ifndef F_P}^{$endif} do
    begin
       //Hide;
      { if not IsMain then
        begin
         Visible := false;
         //CreateWindow;
        end; }

       Font.FontName := 'MS Sans Serif';
       Font.FontHeight := -11;

       onShow := _onShow;
       onDestroy := _onDestroy;
       //OnClose := _OnClose;
       //OnMessage := _onMessage;
       Border := 0;
    end;
   InitAdd(load);
end;

destructor THIMainForm.Destroy;
begin
   inherited;
end;

procedure THIMainForm._onDestroy(Obj:PObj);
begin
   Control := nil;
end;

procedure THIMainForm._work_doFlashWindow;
begin
  //FlashWindow(ReadInteger(_Data,_data_Handle,0),true);
  FlashWindow(Applet.Handle,true);
end;

procedure THIMainForm._work_doIcon;
begin
   if _data.data_type = data_icon then
    begin
      Control.Icon := PIcon(_data.idata).handle;
      if isMain then
       Applet.Icon := Control.Icon;
    end;
end;

procedure THIMainForm._work_doBorderStyle;
begin
  SetBorderStyle(ToInteger(_Data));
end;

procedure THIMainForm._onClose;
var dt:TData;
begin
   dt.Data_type := data_null;
   if ReadInteger(dt,_data_Close,0) <> 0 then
      Accept := false
   else
    begin
     if not isMain and (_prop_ShowType = 0) then
      begin
       Control.Hide;
       Accept := false;
      end
     else Accept := true;
     _prop_SavePosition(true);
    end;
   if isMain and Accept then
    begin
     _hi_OnEvent(_event_onClose);
     EventOff;
     Applet := nil;
     Control := nil;
    end;
end;

function THIMainForm._onMessage;
begin
   Result := false;
   if Control=nil then exit; //!!!  - 
   case Msg.message of
     WM_ACTIVATE:
       if Msg.WParam > 0 then
         begin
           _hi_OnEvent(_event_onActivate);
         end
       else if Msg.WParam = 0 then _hi_OnEvent(_event_onDeActivate);
     //WM_CREATE: if IsMain then Applet.SetPosition(_prop_Left,_prop_Top);
     //WM_SHOWWINDOW: if Msg.wParam = 1 then  SendMessage(Control.Handle,WM_USER+34,0,0);//_OnShow(Control);
     WM_CLOSE: begin _onClose(Control,Result);Result := not Result; exit; end;
     WM_SIZE: if isMain and Assigned(Applet) then Applet.Width := Control.Width;
     WM_MOVE:
       begin
         if isMain and Assigned(Applet) then
           Applet.SetPosition(Control.Left,Control.Top);
         if Assigned(Control.OnPaint) then _hi_OnEvent(_event_onMove);
       end;
   end;

   //Result := inherited _onMessage(Msg,Rslt);
   Result := false;
end;

procedure THIMainForm.SetCaption;
begin
   Control.Caption := Value;
   if IsMain and Assigned(Applet) then
    Applet.Caption := Value;
end;

procedure THIMainForm.SetBorderStyle;
begin
  //Control.ExStyle := 0;
  Control.GetWindowHandle;
  with Control{$ifndef F_P}^{$endif} do
   case Value of
     0: Style := Style and not WS_CAPTION and not WS_THICKFRAME; // none
     1: Style := Style and not WS_THICKFRAME; // Single
     2: ; //Sizeble
     3:  //dlg
       begin
         Style := Style and not WS_THICKFRAME and not WS_MAXIMIZEBOX and not WS_MINIMIZEBOX;
         ExStyle := ExStyle or WS_EX_DLGMODALFRAME or WS_EX_WINDOWEDGE;
       end;
     4:  // tool window
       begin
         Style := Style and not WS_THICKFRAME and not WS_MAXIMIZEBOX and not WS_MINIMIZEBOX;
         ExStyle := ExStyle or WS_EX_TOOLWINDOW;
       end;
     5: //size tool window
       begin
         Style := Style and not WS_MAXIMIZEBOX and not WS_MINIMIZEBOX;
         ExStyle := ExStyle or WS_EX_TOOLWINDOW;
       end;
     6:
       begin
         Style := Style and not WS_CAPTION and not WS_THICKFRAME;
         ExStyle := ExStyle or WS_EX_DLGMODALFRAME;
       end;
     7: Style := Style and not WS_CAPTION;
   end;
  //SetForegroundWindow(Control.Handle);
  //if not _prop_ShowIcon then
  //   Control.Style := Control.Style and not WS_CAPTION or WS_ICONIC;
end;

procedure THIMainForm.SetWindowsState;
begin
   case Value of
    0:;
    1: Control.WindowState := wsMinimized;
    2: Control.WindowState := wsMaximized;
   end;
end;

procedure THIMainForm.SetTaskBar;
begin
  if IsMain then
   if (Value = 1)and Assigned(Applet) then
     Applet.ExStyle :={ Applet.ExStyle or} WS_EX_DLGMODALFRAME or WS_EX_TOOLWINDOW;
end;

procedure THIMainForm.SetIcon;
begin
   Control.Icon := Value;
   if isMain and Assigned(Applet) then
    Applet.Icon := Value;
   isIconSet := Value <> 0;
end;

procedure THIMainForm._OnPaint;
begin
   if (BitMap <> nil)and(BitMap.PixelFormat <> pf1bit) then
      BitMap.Draw(DC,0,0);
   _hi_OnEvent(_event_onPaint,integer(Control.Handle));
end;

procedure CreateCoolControl;
  var
      p: ^TColor;//PDWord;
      x, y : Integer;
      FromX: Integer;
      RGN: HRGN;

  procedure AddSubLine;
    var PixelRGN: HRGN;
  begin
    PixelRGN:=CreateRectRgn(FromX,y,x,y+1);
    CombineRgn(RGN,RGN,PixelRGN,rgn_or);
    DeleteObject(PixelRGN);
  end;
begin
  BitMap.PixelFormat := pf32bit;
  RGN := CreateRectRgn(0,0,0,0);
  for y:=0 to BitMap.Height-1 do
    begin
      FromX:=-1;
      p:=BitMap.ScanLine[y];
      for x:=0 to BitMap.Width-1 do
        begin

          if p^ and tr <> tr then
            begin
              if FromX<0 then
                FromX:=x;
            end else
            begin
              if FromX>=0 then
                begin
                  AddSubLine;
                  FromX:=-1;
                end;
            end;
          Inc(p);
        end;
      if FromX>=0 then
        AddSubLine;
    end;
  if _del then
    BitMap.Free;
  SetWindowRgn(Handle,RGN,True);
end;

procedure THIMainForm.SetPicture;
var bmp:PBitmap;
begin
  BitMap := NewBitMap(0,0);
  Bmp := NewBitMap(0,0);
  bmp.Handle := Value;
  BitMap.Assign(bmp);

  CreateCoolControl(Control.GetWindowHandle,bmp,_prop_TransparentColor);
end;

procedure THIMainForm.SetAlphaBlendValue;
begin
   Control.AlphaBlend := Value;
end;

procedure THIMainForm._onMouseDown;
begin
   if _prop_DragForm then
    begin
     ReleaseCapture;
     Control.Perform(WM_SYSCOMMAND, $F012, 0);
    end;
   inherited;
end;

procedure THIMainForm._onShow;
begin                // _debug('ok');
   if not First then
    begin
     SetWindowsState(_prop_WindowsState);
     _prop_SavePosition(false);
     First := true;
    end;
   //if IsVisibleWindow(Control.Handle) then
   _hi_OnEvent(_event_onShow);

end;

procedure THIMainForm.Load;
{$ifdef F_P}
var i:smallint;
{$endif}
begin
   Control.Perform( WM_USER,33,0);
   _hi_OnEvent(_event_onCreate);

   {$ifdef F_P}
   _onShow(Control);
   for i := 0 to Control.ChildCount-1 do
     with Control.Children[i] do
      if not Visible then Visible := false;
   if not _prop_Visible then
    //_debug('ok');
    Control.Hide;
   {$endif}
end;

procedure THIMainForm.Init;
//var hi:PMHHint;
begin
   //SetBorderStyle(_prop_BorderStyle);
   with Control{$ifndef F_P}^{$endif} do
    begin
       OldMes := OnMessage;
       onMouseDown :=  _onMouseDown;
       onMouseMove := _onMouseMove;
       onMouseUp := _onMouseUp;
       OnMouseDblClk := _onDblClick;
       OnMessage := _onMessage;
       OnKeyDown := _onKeyDown;
       onKeyUp := _onKeyUp;
       onResize := _onResize;

       SetPosition(_prop_Left,_prop_Top);
       Align := _prop_Align;
       Color := _prop_Color;
       //Ctl3D := _prop_Ctl3D = 0;
       //Transparent := _prop_Transparent;
       Font.Color := _prop_Font.Color;
       {$ifdef F_P}

       {$else}
       Font.FontStyle := TFontStyle( pointer(@_prop_Font.Style)^ );
       {$endif}
       Font.FontName :=  _prop_Font.Name;
       Font.FontHeight := 6 + _prop_Font.Size;
       
       if not _prop_visible or (_prop_ShowType = 1) then
         Hide
       else if not isMain then Show;
       Enabled := _prop_Enabled;

       if not isMain and not isIconSet then
         Icon := Applet.Children[0].Icon;
    end;

   //SetBorderStyle(_prop_BorderStyle);
   Control.OnPaint := _OnPaint;
   SetAlphaBlendValue(_prop_AlphaBlendValue);

   if _prop_ClientSize then
     begin
       Control.ClientWidth := _prop_Width;
       Control.ClientHeight := _prop_Height;
     end
   else Control.SetSize(_prop_Width,_prop_Height);
   _prop_Position;
end;

procedure THIMainForm.Start;
begin
  if Assigned(Applet) then
    Applet.Visible := _prop_Visible;
  EventOn;
  InitDo;
end;

procedure THIMainForm.None;
begin
end;

procedure THIMainForm.Registry;
var
  pkey: HKey;
  DataType, size, Disposition, tmp: Integer;
begin
   if State then
    begin
     if RegCreateKeyEx(HKEY_CURRENT_USER,PChar('Software\' + _prop_SavePosName), 0, nil,
        REG_OPTION_NON_VOLATILE, KEY_ALL_ACCESS, nil, pkey, @Disposition) = ERROR_SUCCESS
       then
         begin
            tmp:=Control.Left;  RegSetValueEx(pkey, PChar('Left'),  0, REG_DWORD, @tmp, SizeOf(Integer));
            tmp:=Control.Top;   RegSetValueEx(pkey, PChar('Top'),   0, REG_DWORD, @tmp, SizeOf(Integer));
            tmp:=Control.Height;RegSetValueEx(pkey, PChar('Height'),0, REG_DWORD, @tmp, SizeOf(Integer));
            tmp:=Control.Width; RegSetValueEx(pkey, PChar('Width'), 0, REG_DWORD, @tmp, SizeOf(Integer));
            RegCloseKey(pkey);
         end;
    end
   else
    begin
      if RegOpenKeyEx(HKEY_CURRENT_USER,PChar('Software\' + _prop_SavePosName), 0, KEY_READ , pkey) = ERROR_SUCCESS
      then begin
         size:=SizeOf(Integer);
         DataType:=REG_DWORD;
         if RegQueryValueEx(pkey,'Left',nil,@DataType,PByte(@tmp),@size)=ERROR_SUCCESS
         then Control.Left:=tmp;
         if RegQueryValueEx(pkey,'Top',nil,@DataType,PByte(@tmp),@size)=ERROR_SUCCESS
         then Control.Top:=tmp;
         if RegQueryValueEx(pkey,'Height',nil,@DataType,PByte(@tmp),@size)=ERROR_SUCCESS
         then Control.Height:=tmp;
         if RegQueryValueEx(pkey,'Width',nil,@DataType,PByte(@tmp),@size)=ERROR_SUCCESS
         then Control.Width:=tmp;
         RegCloseKey(pkey);
      end;
    end;
end;

procedure THIMainForm.IniFile;
var Ini:PIniFile;
begin
   Ini := OpenIniFile(GetStartDir + _prop_SavePosName + '.ini');
   Ini.Section := Control.Caption;
   with Control{$ifndef F_P}^{$endif} do
    if State then
     begin
      Ini.Mode := ifmWrite;
      Ini.ValueInteger('Left',Left);
      Ini.ValueInteger('Top',Top);
      Ini.ValueInteger('Width',Width);
      Ini.ValueInteger('Height',Height);
     end
    else
     begin
      Ini.Mode := ifmRead;
      Left := Ini.ValueInteger('Left',Left);
      Top := Ini.ValueInteger('Top',Top);
      Width := Ini.ValueInteger('Width',Width);
      Height := Ini.ValueInteger('Height',Height);
     end;
   Ini.Free;
end;

procedure THIMainForm.poNone;
begin
end;

procedure THIMainForm.poCenter;
begin
  Control.Left := ScreenWidth shr 1 - Control.Width shr 1;
  Control.Top := ScreenHeight shr 1 - Control.Height shr 1;
end;

procedure THIMainForm._work_doCaption;
var Str:string;
begin
   Str := ToString(Data);
   SetWindowText( Control.Handle, @Str[ 1 ] );
end;

procedure THIMainForm._work_doRestore;
begin
   Applet.WindowState := wsNormal;
end;

procedure THIMainForm._work_doMinimize;
begin
   Applet.WindowState := wsMinimized;
end;

procedure THIMainForm._work_doAlphaBlendValue;
begin
   Control.AlphaBlend := ToInteger(Data);
end;

procedure THIMainForm._work_doClose;
begin
   _prop_SavePosition(true);
   if IsMain then
     PostMessage(Control.Handle,WM_QUIT,0,0)
   else if Control.Visible then
     Control.Close;
end;

procedure THIMainForm._work_doVisible;
var i:word;
begin
   if not ReadBool(Data) then
     Control.Hide
   else if _prop_ShowType = 0 then
     begin
       Control.Show;
       if Control.ChildCount > 0 then
        for i := 0 to Control.ChildCount-1 do
         Control.Children[i].Perform(WM_SIZE,0,0);
     end
   else
    begin
      Control.ShowModal;
      Control.Hide;
    end;
end;

procedure THIMainForm._work_doPicture;
var bmp:PBitmap;
begin
   bmp := ReadBitmap(Data,NULL,nil);
   if bmp <> nil then
    begin
     if BitMap = nil then
       BitMap := NewBitmap(0,0);
     BitMap.Assign(bmp);
     CreateCoolControl(Control.Handle, BitMap, _prop_TransparentColor, false);
     Control.Invalidate;
    end;
end;

end.